#!/usr/bin/env python

import random
from eventlet import api, processes, proc, coros, exc
import sys
from pprint import pprint
from twisted.internet import error
from select import error as select_error

def vncserver(clientsock):
    print 'choosing random port...'
    while True:
        port = random.randrange(1024,65535)
        try:
            tmpls = api.tcp_listener(('127.0.0.1', port), 1)
            break
        except:
            pass
    print 'random port %d chosen' % port

    print 'starting x11vnx -rfbversion 3.3 -connect 127.0.0.1:%d -q -inetd' % port
    x11vnc = processes.Process('x11vnc', ['-rfbversion', '3.3', '-connect', '127.0.0.1:%d' % port, '-inetd'])
    print 'accepting socket connects on 127.0.0.1:%d' % port
    x11sock, (raddr, rport) = tmpls.accept()
    print 'connection made, closing listener'
    tmpls.close()

    def log_x11vnc():
        try:
            i = 0
            while True:
                ln = x11vnc.readline()
                if ln:
                    print('%.3d %s' % (i, ln[:-1]))
                    i += 1
                else:
                    break
        except select_error:
            pass

    x11vnc_log = proc.spawn(log_x11vnc)

    #PACKETSIZE = 1536
    PACKETSIZE = 2**16
    #PACKETSIZE = 1024
    #PACKETSIZE = 16384
    #PACKETSIZE = 2000
    def sock2sock(sock1, sock2):
        try:
            while True:
                data = sock1.recv(PACKETSIZE)
                if not data:
                    break
                while data:
                    data = data[sock2.send(data):]
        except (proc.LinkedCompleted,
                error.ConnectionDone,
                select_error        ):
            pass

        try:
            sock1.close()
        except (proc.LinkedCompleted,
                error.ConnectionDone,
                select_error        ):
            pass
        try:
            sock2.close()
        except (proc.LinkedCompleted,
                error.ConnectionDone,
                select_error        ):
            pass
        try:
            x11vnc.close()
        except (proc.LinkedCompleted,
                error.ConnectionDone,
                select_error        ):
            pass

    x2c = proc.spawn(sock2sock, clientsock, x11sock)
    c2x = proc.spawn(sock2sock, x11sock, clientsock)
    x2c.link(c2x)
    c2x.link(x2c)
    print 'Copying data'
    x11vnc.wait()
    print 'vncserver done'

if __name__ == '__main__':
    print 'listening for incoming VNC connections on 0.0.0.0:5900...'
    ls = api.tcp_listener(('0.0.0.0', 5900), 1)
    sock, (addr, port) = ls.accept()
    print 'client connected (%s:%d)' % (addr, port)
    ls.close()
    vncserver(sock).wait()

